// eslint-disable-next-line import/no-extraneous-dependencies
import React, { FC } from 'react';
// eslint-disable-next-line import/no-extraneous-dependencies
import styled from 'styled-components';

// eslint-disable-next-line import/no-extraneous-dependencies
import { globalTheme } from '@clds/component-theme';
// eslint-disable-next-line @nrwl/nx/enforce-module-boundaries
import { Cloud } from '@clds/icon';

const { palette, spacing } = globalTheme;

const Button = styled.div`
  height: ${spacing.xxl};
  width: ${spacing.xxl};
`;

const Content = styled.div``;

const Root = styled.div`
  display: inline-flex;
  align-items: center;
  cursor: pointer;

  margin: ${spacing.md};
  color: ${palette.contrastHigh};

  background-color: ${palette.surface};

  &,
  ${Button} {
    border-radius: 100px;
  }
  ${Button} {
    background-color: ${palette.primary};
    border-bottom-right-radius: 0;
    border-top-right-radius: 0;
    display: flex;
    justify-content: center;
    align-items: center;
    svg path {
      fill: ${palette.surface};
    }
  }
  ${Content} {
    padding: 0 ${spacing.lg};
  }
`;

export const GlobalMixins: FC = ({ children }) => (
  <Root>
    <Button>
      <Cloud size="lg" />
    </Button>
    <Content>{children}</Content>
  </Root>
);
