// eslint-disable-next-line import/no-extraneous-dependencies
import React, { FC, ReactNode } from 'react';
// eslint-disable-next-line import/no-extraneous-dependencies
import styled from 'styled-components';

// eslint-disable-next-line import/no-extraneous-dependencies
import { globalTheme } from '@clds/component-theme';

const Root = styled.div`
  display: inline-flex;
  align-items: center;
  box-shadow: ${globalTheme.shadow.sm};

  background-color: ${globalTheme.palette.secondary};
  color: ${globalTheme.palette.contrastHigh};
`;
const Button = styled.div`
  background-color: ${globalTheme.palette.primary};
  height: ${globalTheme.spacing.xxl};
  width: ${globalTheme.spacing.xxl};
`;
const Content = styled.div`
  padding: 0 ${globalTheme.spacing.md};
`;
export const WithGlobalMixins: FC<{ children: ReactNode }> = ({ children }) => (
  <Root>
    <Button />
    <Content>{children}</Content>
  </Root>
);
