import React from 'react';
import styled from 'styled-components';

import theme from '@clds/themes';

type Spacing = 'xxs' | 'xs' | 'sm' | 'md' | 'xl' | 'xxl';
const spacing: Array<Spacing> = ['xxs', 'xs', 'sm', 'md', 'xl', 'xxl'];

const Wrapper = styled.div`
  display: flex;
  flex-direction: column;
`;

const Row = styled.div`
  display: flex;
  align-items: center;
  margin-top: ${theme.spacing.lg};
  color: ${theme.palette.contrastLow};
`;

const Box = styled.div`
  width: ${({ size }: { size: Spacing }) => theme.spacing[size]};
  height: ${({ size }: { size: Spacing }) => theme.spacing[size]};
  margin-right: ${theme.spacing.lg};
  background-color: ${theme.palette.primary};
`;

export const Default = () => (
  <Wrapper>
    {spacing.map((value) => (
      <Row key={value}>
        <Box size={value} />
        <div>spacing.{value}</div>
      </Row>
    ))}
  </Wrapper>
);
export default { component: Default, title: 'Themes/Spacing' };
